(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('angular2-text-mask'), require('@trycatch/material-extension'), require('rxjs/operators'), require('text-mask-addons/dist/createAutoCorrectedDatePipe'), require('@angular/material'), require('@angular/material-moment-adapter'), require('moment'), require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('@trycatch/material-forms', ['exports', '@angular/common', 'angular2-text-mask', '@trycatch/material-extension', 'rxjs/operators', 'text-mask-addons/dist/createAutoCorrectedDatePipe', '@angular/material', '@angular/material-moment-adapter', 'moment', '@angular/core', '@angular/forms'], factory) :
    (factory((global.trycatch = global.trycatch || {}, global.trycatch['material-forms'] = {}),global.ng.common,global.angular2TextMask,global.materialExtension,global.rxjs.operators,global.createAutoCorrectedDatePipe,global.ng.material,global.ng['material-moment-adapter'],global.moment_,global.ng.core,global.ng.forms));
}(this, (function (exports,common,angular2TextMask,materialExtension,operators,createAutoCorrectedDatePipe,material,materialMomentAdapter,moment_,core,forms) { 'use strict';

    createAutoCorrectedDatePipe = createAutoCorrectedDatePipe && createAutoCorrectedDatePipe.hasOwnProperty('default') ? createAutoCorrectedDatePipe['default'] : createAutoCorrectedDatePipe;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var FormFieldControlType = {
        INPUT_TEXT: "InputText",
        INPUT_NUMBER: "InputNumber",
        AUTOCOMPLETE: "AutoComplete",
    };
    /** @enum {string} */
    var FormFieldEventType = {
        INPUT_CHANGED: "input_changed",
        OPTION_SELECTED: "option_selected",
        CONTROL_CREATED: "control_created",
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} event
     * @return {?}
     */
    function numericKeysOnly(event) {
        /** @type {?} */
        var charCode = event.which ? event.which : event.keyCode;
        if (charCode >= 48 && charCode <= 57) {
            return true;
        }
        return false;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    function numericKeysOnlyWithDecimalPoint(event) {
        /** @type {?} */
        var charCode = event.which ? event.which : event.keyCode;
        if ((charCode >= 48 && charCode <= 57) || charCode === 46) {
            return true;
        }
        return false;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    function alphaNumericKeysOnly(event) {
        /** @type {?} */
        var charCode = event.which ? event.which : event.keyCode;
        if (charCode === 32 ||
            (charCode >= 97 && charCode <= 122) ||
            (charCode >= 65 && charCode <= 90) ||
            (charCode >= 48 && charCode <= 57) // numeric keys
        ) {
            return true;
        }
        return false;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    function alphaKeysOnly(event) {
        /** @type {?} */
        var charCode = event.which ? event.which : event.keyCode;
        if (charCode >= 48 && charCode <= 57) {
            // numeric keys
            return false;
        }
        if (charCode >= 33 && charCode <= 38) {
            // special keys
            return false;
        }
        if (charCode >= 40 && charCode <= 44) {
            // special keys
            return false;
        }
        if (charCode >= 46 && charCode <= 47) {
            // special keys
            return false;
        }
        if (charCode >= 58 && charCode <= 64) {
            // special keys
            return false;
        }
        if (charCode >= 91 && charCode <= 95) {
            // special keys
            return false;
        }
        if (charCode >= 123 && charCode <= 126) {
            // special keys
            return false;
        }
        if (charCode >= 161 && charCode <= 191) {
            // special keys
            return false;
        }
        if (charCode === 8217) {
            // special keys
            return false;
        }
        return true;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var FromFieldControl = /** @class */ (function () {
        function FromFieldControl(__formGroupDirective) {
            this.keyRestrictionsFunctionMap = {
                "numeric-only": numericKeysOnly,
                "numeric-with-decimal-point": numericKeysOnlyWithDecimalPoint,
                "alpha-numeric": alphaNumericKeysOnly,
                "alpha-only": alphaKeysOnly
            };
            this.event = new core.EventEmitter();
            this._keyRestrictionFunction = this.__keyRestrictionFunction;
            this.formGroupDirective = __formGroupDirective;
            this.event.emit(( /** @type {?} */({
                type: FormFieldEventType.CONTROL_CREATED
            })));
            if (!__formGroupDirective) {
                console.error("form field controls can be used within form group container");
            }
        }
        Object.defineProperty(FromFieldControl.prototype, "keyRestrictions", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                if (!!val) {
                    this._keyRestrictionFunction = this.keyRestrictionsFunctionMap[val];
                }
                else {
                    this._keyRestrictionFunction = this.__keyRestrictionFunction;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        FromFieldControl.prototype.__keyRestrictionFunction = /**
         * @private
         * @param {?} event
         * @return {?}
         */
            function (event) {
                return true;
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        FromFieldControl.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                if ("controlName" in changes) {
                    if (this.formGroupDirective) {
                        this.formGroup = this.formGroupDirective.form;
                        this._control = this.formGroup.controls[changes.controlName.currentValue];
                        this.__setValidators();
                        this.__pendingSubscription();
                    }
                }
            };
        /**
         * @return {?}
         */
        FromFieldControl.prototype._runReplacement = /**
         * @return {?}
         */
            function () {
                if (this.replacementMap &&
                    this.replacementMap.length > 0 &&
                    this._control) {
                    /** @type {?} */
                    var val_1 = this._control.value.toString();
                    if (val_1) {
                        this.replacementMap.forEach(( /**
                         * @param {?} rm
                         * @return {?}
                         */function (rm) {
                            /** @type {?} */
                            var regEx = new RegExp(rm[0].source, rm[0].flags + "g");
                            val_1 = val_1.replace(regEx, rm[1]);
                        }));
                        this._control.setValue(val_1);
                    }
                }
            };
        /**
         * @private
         * @return {?}
         */
        FromFieldControl.prototype.__setValidators = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.validationFn) {
                    this._control.setValidators(this.validationFn);
                }
            };
        /**
         * @private
         * @return {?}
         */
        FromFieldControl.prototype.__pendingSubscription = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                if (this._control) {
                    this._control.statusChanges.subscribe(( /**
                     * @param {?} status
                     * @return {?}
                     */function (status) {
                        /** @type {?} */
                        var msg = _this.controlName + " status is : " + status;
                        console.log(msg);
                        console.log(_this._control.errors);
                        _this._status = status;
                    }));
                }
            };
        Object.defineProperty(FromFieldControl.prototype, "__control", {
            get: /**
             * @protected
             * @return {?}
             */ function () {
                return this._control;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} controlType
         * @return {?}
         */
        FromFieldControl.prototype.__controlInfo = /**
         * @param {?} controlType
         * @return {?}
         */
            function (controlType) {
                return {
                    name: this.controlName,
                    type: controlType,
                    abstractControl: this.__control
                };
            };
        Object.defineProperty(FromFieldControl.prototype, "valid", {
            get: /**
             * @return {?}
             */ function () {
                return this.__control
                    ? this.__control.dirty &&
                        !this.__control.errors &&
                        !this.__control.pending
                    : undefined;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FromFieldControl.prototype, "error", {
            get: /**
             * @return {?}
             */ function () {
                if (this.__control) {
                    /** @type {?} */
                    var ctrl_1 = this.__control;
                    if (ctrl_1.errors) {
                        if (ctrl_1.hasError("required")) {
                            return this.label + " is required";
                        }
                        if (ctrl_1.hasError("error")) {
                            return "" + ctrl_1.errors["error"];
                        }
                        if (this.errorFn) {
                            /** @type {?} */
                            var err = this.errorFn(ctrl_1.errors, this.parent);
                            if (err) {
                                return err;
                            }
                            else {
                                setTimeout(( /**
                                 * @return {?}
                                 */function () {
                                    ctrl_1.setErrors(null);
                                }));
                            }
                        }
                    }
                }
                return undefined;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @protected
         * @param {?} val
         * @return {?}
         */
        FromFieldControl.prototype._cleanMaskValue = /**
         * @protected
         * @param {?} val
         * @return {?}
         */
            function (val) {
                return val ? val.replace(/[^\x00-\x7F]/g, "") : val;
            };
        FromFieldControl.propDecorators = {
            label: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            hint: [{ type: core.Input }],
            controlName: [{ type: core.Input }],
            required: [{ type: core.Input }],
            validImage: [{ type: core.Input }],
            appearance: [{ type: core.Input }],
            floatLabel: [{ type: core.Input }],
            color: [{ type: core.Input }],
            invalidImage: [{ type: core.Input }],
            parent: [{ type: core.Input }],
            validationFn: [{ type: core.Input }],
            errorFn: [{ type: core.Input }],
            keyRestrictions: [{ type: core.Input }],
            replacementMap: [{ type: core.Input }],
            event: [{ type: core.Output }]
        };
        return FromFieldControl;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var InputFormFieldComponent = /** @class */ (function (_super) {
        __extends(InputFormFieldComponent, _super);
        function InputFormFieldComponent(__formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this.maxLength = -1;
            _this.minLength = -1;
            return _this;
        }
        /**
         * @return {?}
         */
        InputFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        InputFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-input-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<input\n\t\tmatInput\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t(keypress)=\"_keyRestrictionFunction($event)\"\n\t\t(blur)=\"_runReplacement()\"\n\t\t[required]=\"required\"\n\t\t[maxlength]=\"maxLength > 0 ? maxLength : undefined\"\n\t\ttype=\"text\"\n\t/>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<mat-spinner\n\t\t*ngIf=\"_status === 'PENDING'\"\n\t\t[diameter]=\"18\"\n\t\t[strokeWidth]=\"3\"\n\t></mat-spinner>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}"]
                    }] }
        ];
        /** @nocollapse */
        InputFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        InputFormFieldComponent.propDecorators = {
            maxLength: [{ type: core.Input }],
            minLength: [{ type: core.Input }]
        };
        return InputFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AutoCompleteFormFieldComponent = /** @class */ (function (_super) {
        __extends(AutoCompleteFormFieldComponent, _super);
        function AutoCompleteFormFieldComponent(__formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this.charThreshold = 2;
            return _this;
        }
        /**
         * @return {?}
         */
        AutoCompleteFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        /**
         * @param {?} eventData
         * @return {?}
         */
        AutoCompleteFormFieldComponent.prototype._optionSelected = /**
         * @param {?} eventData
         * @return {?}
         */
            function (eventData) {
                /** @type {?} */
                var eventVal = ( /** @type {?} */({
                    type: FormFieldEventType.OPTION_SELECTED,
                    control: this.__controlInfo(FormFieldControlType.AUTOCOMPLETE)
                }));
                if (eventData) {
                    eventVal.data = eventData;
                }
                else {
                    this.__control.reset();
                }
                this.event.emit(eventVal);
            };
        /**
         * @param {?} eventData
         * @return {?}
         */
        AutoCompleteFormFieldComponent.prototype._inputChanged = /**
         * @param {?} eventData
         * @return {?}
         */
            function (eventData) {
                this.event.emit(( /** @type {?} */({
                    type: FormFieldEventType.INPUT_CHANGED,
                    data: eventData,
                    control: this.__controlInfo(FormFieldControlType.AUTOCOMPLETE)
                })));
            };
        AutoCompleteFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-auto-complete-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<trycatch-mat-auto-complete\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t[options]=\"options\"\n\t\t[displayProperty]=\"displayProperty\"\n\t\t[displayFn]=\"displayFn\"\n\t\t[charThreshold]=\"charThreshold\"\n\t\t[optionDisplayFn]=\"optionDisplayFn\"\n\t\t[optionClassFn]=\"optionClassFn\"\n\t\t[required]=\"required\"\n\t\t[options$]=\"options$\"\n\t\t(optionSelected)=\"_optionSelected($event)\"\n\t\t(inputChanged)=\"_inputChanged($event)\"\n\t\t[classList]=\"classList\"\n\t>\n\t</trycatch-mat-auto-complete>\n\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}"]
                    }] }
        ];
        /** @nocollapse */
        AutoCompleteFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        AutoCompleteFormFieldComponent.propDecorators = {
            options: [{ type: core.Input }],
            options$: [{ type: core.Input }],
            displayProperty: [{ type: core.Input }],
            displayFn: [{ type: core.Input }],
            optionDisplayFn: [{ type: core.Input }],
            optionClassFn: [{ type: core.Input }],
            charThreshold: [{ type: core.Input }],
            classList: [{ type: core.Input }]
        };
        return AutoCompleteFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NumberFormFieldComponent = /** @class */ (function (_super) {
        __extends(NumberFormFieldComponent, _super);
        function NumberFormFieldComponent(__formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this.step = 0.1;
            return _this;
        }
        /**
         * @return {?}
         */
        NumberFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this._control.valueChanges.subscribe(( /**
                 * @param {?} val
                 * @return {?}
                 */function (val) {
                    if (val) {
                        if (_this.minValue) {
                            if (val < _this.minValue) {
                                console.log("setting up min value error");
                                _this._control.setErrors({
                                    error: "value out of range. Value less then min allowed value"
                                });
                            }
                        }
                        if (_this.maxValue) {
                            if (val > _this.maxValue) {
                                console.log("setting up max value error");
                                _this._control.setErrors({
                                    error: "value out of range. Value greater then max allowed value"
                                });
                            }
                        }
                    }
                    else {
                        _this._control.setErrors(null);
                    }
                }));
            };
        NumberFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-number-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<input\n\t\tmatInput\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t[required]=\"required\"\n\t\ttype=\"number\"\n\t\t[step]=\"step\"\n\t\t[attr.min]=\"minValue\"\n\t\t[attr.max]=\"maxValue\"\n\t/>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}"]
                    }] }
        ];
        /** @nocollapse */
        NumberFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        NumberFormFieldComponent.propDecorators = {
            step: [{ type: core.Input }],
            minValue: [{ type: core.Input }],
            maxValue: [{ type: core.Input }]
        };
        return NumberFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TextAreaFormFieldComponent = /** @class */ (function (_super) {
        __extends(TextAreaFormFieldComponent, _super);
        function TextAreaFormFieldComponent(ngZone, __formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this.ngZone = ngZone;
            _this.minRows = 3;
            _this.maxRows = 15;
            return _this;
        }
        /**
         * @return {?}
         */
        TextAreaFormFieldComponent.prototype.triggerResize = /**
         * @return {?}
         */
            function () {
                var _this = this;
                // Wait for changes to be applied, then trigger textarea resize.
                this.ngZone.onStable
                    .pipe(operators.take(1))
                    .subscribe(( /**
             * @return {?}
             */function () { return _this.autosize.resizeToFitContent(true); }));
            };
        /**
         * @return {?}
         */
        TextAreaFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        TextAreaFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-text-area-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<textarea\n\t\tmatInput\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t[required]=\"required\"\n\t\ttype=\"text\"\n\t\tcdkTextareaAutosize\n\t\t#autosize=\"cdkTextareaAutosize\"\n\t\t[cdkAutosizeMinRows]=\"minRows\"\n\t\t[cdkAutosizeMaxRows]=\"maxRows\"\n\t></textarea>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}"]
                    }] }
        ];
        /** @nocollapse */
        TextAreaFormFieldComponent.ctorParameters = function () {
            return [
                { type: core.NgZone },
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        TextAreaFormFieldComponent.propDecorators = {
            minRows: [{ type: core.Input }],
            maxRows: [{ type: core.Input }],
            cols: [{ type: core.Input }],
            autosize: [{ type: core.ViewChild, args: ["autosize",] }]
        };
        return TextAreaFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MaskedFormFieldComponent = /** @class */ (function (_super) {
        __extends(MaskedFormFieldComponent, _super);
        function MaskedFormFieldComponent(__formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this._placeholderDate = "01";
            _this._placeholderMonth = "01";
            _this._placeholderYear = "1900";
            _this.maxLength = -1;
            _this.minLength = -1;
            return _this;
        }
        Object.defineProperty(MaskedFormFieldComponent.prototype, "mask", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                if (val) {
                    this._mask = {
                        mask: val,
                        guide: true,
                        placeholderChar: "\u2000"
                    };
                    if (this._autoCorrectedDatePipe) {
                        this._mask.pipe = this._autoCorrectedDatePipe;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaskedFormFieldComponent.prototype, "dateFormat", {
            set: /**
             * @param {?} format
             * @return {?}
             */ function (format) {
                if (format) {
                    this._autoCorrectedDatePipe = createAutoCorrectedDatePipe(format);
                    this.placeholder = format
                        .replace("dd", this._placeholderDate)
                        .replace("mm", this._placeholderMonth)
                        .replace("yyyy", this._placeholderYear);
                    if (this._mask) {
                        this._mask.pipe = this._autoCorrectedDatePipe;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MaskedFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () { };
        MaskedFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-masked-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<input\n\t\tmatInput\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t[required]=\"required\"\n\t\t[maxlength]=\"maxLength > 0 ? maxLength : undefined\"\n\t\t(keypress)=\"_keyRestrictionFunction($event)\"\n\t\ttype=\"text\"\n\t\t[textMask]=\"_mask\"\n\t/>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<mat-spinner\n\t\t*ngIf=\"_status === 'PENDING'\"\n\t\t[diameter]=\"18\"\n\t\t[strokeWidth]=\"3\"\n\t></mat-spinner>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}"]
                    }] }
        ];
        /** @nocollapse */
        MaskedFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        MaskedFormFieldComponent.propDecorators = {
            maxLength: [{ type: core.Input }],
            minLength: [{ type: core.Input }],
            mask: [{ type: core.Input }],
            dateFormat: [{ type: core.Input }]
        };
        return MaskedFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DATE_FORMATS = {
        parse: {
            dateInput: "L"
        },
        display: {
            dateInput: "L",
            monthYearLabel: "MMM YYYY",
            dateA11yLabel: "L",
            monthYearA11yLabel: "MMMM YYYY"
        }
    };
    /** @type {?} */
    var moment = moment_;
    var MomentFormFieldComponent = /** @class */ (function (_super) {
        __extends(MomentFormFieldComponent, _super);
        function MomentFormFieldComponent(__formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this.__dateMask = [
                /\d/,
                /\d/,
                "/",
                /\d/,
                /\d/,
                "/",
                /[1-2]/,
                /\d/,
                /\d/,
                /\d/
            ];
            _this.__dpControl = new forms.FormControl();
            _this._mask = {
                mask: _this.__dateMask,
                guide: true,
                placeholderChar: "\u2000",
                pipe: createAutoCorrectedDatePipe("dd/mm/yyyy")
            };
            _this.placeholder = "01/01/1900";
            _this.hint = "format: 01/01/1900";
            return _this;
        }
        Object.defineProperty(MomentFormFieldComponent.prototype, "startDate", {
            set: /**
             * @param {?} val
             * @return {?}
             */ function (val) {
                /** @type {?} */
                var mmt = moment(val, "DD/MM/YYYY");
                if (mmt.isValid()) {
                    // this.__dpControl.setValue(mmt, { emitEvent: false });
                    this._startDate = mmt;
                    this._bkpStartDate = mmt;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        MomentFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.__dpControl.valueChanges.subscribe(( /**
                 * @param {?} val
                 * @return {?}
                 */function (val) {
                    /** @type {?} */
                    var dt = val.format("DD/MM/YYYY");
                    _this._control.setValue(dt, { emitEvent: false });
                    _this._control.markAsTouched();
                    _this._startDate = val;
                }));
                this._control.valueChanges.subscribe(( /**
                 * @param {?} val
                 * @return {?}
                 */function (val) {
                    /** @type {?} */
                    var dt = _this._cleanMaskValue(val);
                    if (dt.length === 10) {
                        /** @type {?} */
                        var mmt = moment(dt, "DD/MM/YYYY");
                        if (mmt.isValid()) {
                            _this.__dpControl.setValue(mmt, { emitEvent: false });
                            _this._startDate = mmt;
                        }
                    }
                    else if (dt.length === 0) {
                        _this._startDate = _this._bkpStartDate;
                    }
                }));
            };
        MomentFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-moment-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<input\n\t\tmatInput\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t[required]=\"required\"\n\t\t[textMask]=\"_mask\"\n\t/>\n\t<input\n\t\tmatInput\n\t\t[hidden]=\"true\"\n\t\t[formControl]=\"__dpControl\"\n\t\t[matDatepicker]=\"picker\"\n\t\t[required]=\"required\"\n\t\t[matDatepickerFilter]=\"dateFilterFn\"\n\t/>\n\t<mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n\t<mat-datepicker\n\t\t#picker\n\t\tdisabled=\"false\"\n\t\tstartView=\"month\"\n\t\t[startAt]=\"_startDate\"\n\t></mat-datepicker>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        providers: [
                            // `MomentDateAdapter` and `MAT_MOMENT_DATE_FORMATS` can be automatically provided by importing
                            // `MatMomentDateModule` in your applications root module. We provide it at the component level
                            // here, due to limitations of our example generation script.
                            { provide: material.MAT_DATE_LOCALE, useValue: "en-AU" },
                            {
                                provide: material.DateAdapter,
                                useClass: materialMomentAdapter.MomentDateAdapter,
                                deps: [material.MAT_DATE_LOCALE]
                            },
                            { provide: material.MAT_DATE_FORMATS, useValue: DATE_FORMATS }
                        ],
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}:host mat-datepicker-toggle ::ng-deep button{width:30px;height:30px}:host mat-datepicker-toggle ::ng-deep button span.mat-button-wrapper{display:block}"]
                    }] }
        ];
        /** @nocollapse */
        MomentFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        MomentFormFieldComponent.propDecorators = {
            dateFilterFn: [{ type: core.Input }],
            startDate: [{ type: core.Input }]
        };
        return MomentFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var MONTH_YEAR_FORMAT = {
        parse: {
            dateInput: "MM/YYYY"
        },
        display: {
            dateInput: "MM/YYYY",
            monthYearLabel: "MMM YYYY",
            dateA11yLabel: "LL",
            monthYearA11yLabel: "MMMM YYYY"
        }
    };
    /** @type {?} */
    var moment$1 = moment_;
    var ExpiryMonthFormFieldComponent = /** @class */ (function (_super) {
        __extends(ExpiryMonthFormFieldComponent, _super);
        function ExpiryMonthFormFieldComponent(__formGroupDirective) {
            var _this = _super.call(this, __formGroupDirective) || this;
            _this.__val = moment$1();
            return _this;
        }
        /**
         * @return {?}
         */
        ExpiryMonthFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (this._control.value) {
                    this.__val = moment$1(this._control.value, "MM/YYYY");
                    // } else {
                    // 	this._control.setValue(this.__val);
                }
            };
        /**
         * @param {?} normalizedYear
         * @return {?}
         */
        ExpiryMonthFormFieldComponent.prototype._chosenYearHandler = /**
         * @param {?} normalizedYear
         * @return {?}
         */
            function (normalizedYear) {
                console.log("control : ", this._control);
                /** @type {?} */
                var ctrlValue = this._control.value || this.__val;
                console.log("control value : ", ctrlValue);
                ctrlValue.year(normalizedYear.year());
                if (this._control.value) {
                    this._control.setValue(ctrlValue);
                }
                else {
                    this.__val = ctrlValue;
                }
                console.log("control value : ", this._control.value);
            };
        /**
         * @param {?} normlizedMonth
         * @param {?} datepicker
         * @return {?}
         */
        ExpiryMonthFormFieldComponent.prototype._chosenMonthHandler = /**
         * @param {?} normlizedMonth
         * @param {?} datepicker
         * @return {?}
         */
            function (normlizedMonth, datepicker) {
                /** @type {?} */
                var ctrlValue = this._control.value || this.__val;
                ctrlValue.month(normlizedMonth.month());
                if (this._control.value) {
                    this._control.setValue(ctrlValue);
                }
                else {
                    this.__val = ctrlValue;
                    this._control.setValue(this.__val);
                }
                datepicker.close();
            };
        ExpiryMonthFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-expiry-month-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<input\n\t\tmatInput\n\t\treadonly\n\t\t(focus)=\"picker.open()\"\n\t\t[matDatepicker]=\"picker\"\n\t\t[formControl]=\"_control\"\n\t\t[placeholder]=\"placeholder\"\n\t\t[required]=\"required\"\n\t\t[matDatepickerFilter]=\"filterFn\"\n\t/>\n\t<mat-datepicker-toggle matSuffix [for]=\"picker\"></mat-datepicker-toggle>\n\t<mat-datepicker\n\t\t#picker\n\t\tdisabled=\"false\"\n\t\tstartView=\"multi-year\"\n\t\t(yearSelected)=\"_chosenYearHandler($event)\"\n\t\t(monthSelected)=\"_chosenMonthHandler($event, picker)\"\n\t></mat-datepicker>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        providers: [
                            // `MomentDateAdapter` and `MAT_MOMENT_DATE_FORMATS` can be automatically provided by importing
                            // `MatMomentDateModule` in your applications root module. We provide it at the component level
                            // here, due to limitations of our example generation script.
                            { provide: material.MAT_DATE_LOCALE, useValue: "en-AU" },
                            {
                                provide: material.DateAdapter,
                                useClass: materialMomentAdapter.MomentDateAdapter,
                                deps: [material.MAT_DATE_LOCALE]
                            },
                            { provide: material.MAT_DATE_FORMATS, useValue: MONTH_YEAR_FORMAT }
                        ],
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host img.valid-tick{position:absolute;right:0;top:50%;margin-top:-6px}:host mat-spinner{position:absolute;right:0;bottom:5px}"]
                    }] }
        ];
        /** @nocollapse */
        ExpiryMonthFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        ExpiryMonthFormFieldComponent.propDecorators = {
            filterFn: [{ type: core.Input }]
        };
        return ExpiryMonthFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SelectFormFieldComponent = /** @class */ (function (_super) {
        __extends(SelectFormFieldComponent, _super);
        function SelectFormFieldComponent(__formGroupDirective) {
            return _super.call(this, __formGroupDirective) || this;
        }
        /**
         * @return {?}
         */
        SelectFormFieldComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.optionDisplayFn = this.optionDisplayFn || this.__displayFn;
                this.optionClassFn = this.optionClassFn || this.__classFn;
            };
        /**
         * @private
         * @param {?=} option
         * @return {?}
         */
        SelectFormFieldComponent.prototype.__classFn = /**
         * @private
         * @param {?=} option
         * @return {?}
         */
            function (option) {
                return undefined;
            };
        /**
         * @private
         * @param {?=} option
         * @return {?}
         */
        SelectFormFieldComponent.prototype.__displayFn = /**
         * @private
         * @param {?=} option
         * @return {?}
         */
            function (option) {
                if (!option) {
                    return undefined;
                }
                return this.__isPrimitiveType(option)
                    ? option
                    : option[this.displayProperty];
            };
        /**
         * @private
         * @param {?} val
         * @return {?}
         */
        SelectFormFieldComponent.prototype.__isPrimitiveType = /**
         * @private
         * @param {?} val
         * @return {?}
         */
            function (val) {
                /** @type {?} */
                var primitiveTypes = [
                    "boolean",
                    "number",
                    "string",
                    "undefined",
                    "null"
                ];
                /** @type {?} */
                var valType = typeof val;
                return primitiveTypes.indexOf(valType) >= 0;
            };
        SelectFormFieldComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "tc-select-form-field",
                        template: "<mat-form-field\n\t[color]=\"color\"\n\t[appearance]=\"appearance\"\n\t[floatLabel]=\"floatLabel\"\n>\n\t<mat-label [innerHtml]=\"label\"></mat-label>\n\t<mat-select [formControl]=\"_control\" [required]=\"required\">\n\t\t<ng-container *ngIf=\"options; else observableOptions\">\n\t\t\t<mat-option\n\t\t\t\t*ngFor=\"let option of options\"\n\t\t\t\t[value]=\"option\"\n\t\t\t\t[ngClass]=\"optionClassFn(option)\"\n\t\t\t>\n\t\t\t\t{{ optionDisplayFn(option) }}\n\t\t\t</mat-option>\n\t\t</ng-container>\n\t\t<ng-template #observableOptions>\n\t\t\t<mat-option\n\t\t\t\t*ngFor=\"let option of options$ | async\"\n\t\t\t\t[value]=\"option\"\n\t\t\t\t[ngClass]=\"optionClassFn(option)\"\n\t\t\t>\n\t\t\t\t{{ optionDisplayFn(option) }}\n\t\t\t</mat-option>\n\t\t</ng-template>\n\t</mat-select>\n\t<mat-hint [innerHtml]=\"hint\"></mat-hint>\n\t<mat-error [innerHtml]=\"error\"></mat-error>\n\t<img *ngIf=\"valid && validImage\" class=\"valid-tick\" [src]=\"validImage\" />\n</mat-form-field>\n",
                        styles: [":host{width:100%;display:block}:host mat-form-field{width:100%;line-height:inherit}:host mat-spinner{position:absolute;right:0;bottom:5px}:host img.valid-tick{position:absolute;right:0;top:66%;margin-top:-6px}"]
                    }] }
        ];
        /** @nocollapse */
        SelectFormFieldComponent.ctorParameters = function () {
            return [
                { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }, { type: core.Inject, args: [forms.FormGroupDirective,] }] }
            ];
        };
        SelectFormFieldComponent.propDecorators = {
            options: [{ type: core.Input }],
            options$: [{ type: core.Input }],
            displayProperty: [{ type: core.Input }],
            classList: [{ type: core.Input }],
            optionDisplayFn: [{ type: core.Input }],
            optionClassFn: [{ type: core.Input }]
        };
        return SelectFormFieldComponent;
    }(FromFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TryCatchMaterialFormsModule = /** @class */ (function () {
        function TryCatchMaterialFormsModule() {
        }
        TryCatchMaterialFormsModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule,
                            material.MatCommonModule,
                            material.MatInputModule,
                            material.MatDatepickerModule,
                            material.MatFormFieldModule,
                            materialMomentAdapter.MatMomentDateModule,
                            material.MatProgressSpinnerModule,
                            material.MatSelectModule,
                            angular2TextMask.TextMaskModule,
                            materialExtension.TryCatchMaterialExtensionModule
                        ],
                        declarations: [
                            InputFormFieldComponent,
                            AutoCompleteFormFieldComponent,
                            NumberFormFieldComponent,
                            TextAreaFormFieldComponent,
                            MaskedFormFieldComponent,
                            MomentFormFieldComponent,
                            ExpiryMonthFormFieldComponent,
                            SelectFormFieldComponent
                        ],
                        exports: [
                            InputFormFieldComponent,
                            AutoCompleteFormFieldComponent,
                            NumberFormFieldComponent,
                            TextAreaFormFieldComponent,
                            MaskedFormFieldComponent,
                            MomentFormFieldComponent,
                            ExpiryMonthFormFieldComponent,
                            SelectFormFieldComponent
                        ]
                    },] }
        ];
        return TryCatchMaterialFormsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.TryCatchMaterialFormsModule = TryCatchMaterialFormsModule;
    exports.InputFormFieldComponent = InputFormFieldComponent;
    exports.AutoCompleteFormFieldComponent = AutoCompleteFormFieldComponent;
    exports.NumberFormFieldComponent = NumberFormFieldComponent;
    exports.TextAreaFormFieldComponent = TextAreaFormFieldComponent;
    exports.MaskedFormFieldComponent = MaskedFormFieldComponent;
    exports.DATE_FORMATS = DATE_FORMATS;
    exports.MomentFormFieldComponent = MomentFormFieldComponent;
    exports.MONTH_YEAR_FORMAT = MONTH_YEAR_FORMAT;
    exports.ExpiryMonthFormFieldComponent = ExpiryMonthFormFieldComponent;
    exports.SelectFormFieldComponent = SelectFormFieldComponent;
    exports.FormFieldControlType = FormFieldControlType;
    exports.FormFieldEventType = FormFieldEventType;
    exports.ɵa = FromFieldControl;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=trycatch-material-forms.umd.js.map