import { EventEmitter, OnChanges, SimpleChanges } from "@angular/core";
import { FormGroup, ValidationErrors, AbstractControl, FormGroupDirective } from "@angular/forms";
import { FormFieldEvent, FormFieldControlType, KeyRestrictionsTypes, FormFieldStatus } from "./form-field-enums";
import { MatFormFieldAppearance, FloatLabelType, ThemePalette } from "@angular/material";
export declare abstract class FromFieldControl implements OnChanges {
    formGroup: FormGroup;
    protected formGroupDirective: FormGroupDirective;
    _control: AbstractControl;
    _status: FormFieldStatus;
    protected keyRestrictionsFunctionMap: {
        [key: string]: (event: any) => boolean;
    };
    label: string;
    placeholder: string;
    hint: string;
    controlName: string;
    required: boolean;
    validImage: string;
    appearance: MatFormFieldAppearance;
    floatLabel: FloatLabelType;
    color: ThemePalette;
    invalidImage: string;
    parent: any;
    validationFn: (control: AbstractControl) => any;
    errorFn: (errors: ValidationErrors, label?: string, control?: AbstractControl) => string;
    keyRestrictions: KeyRestrictionsTypes;
    replacementMap: [RegExp, string][];
    event: EventEmitter<FormFieldEvent>;
    _keyRestrictionFunction: (event: any) => boolean;
    private __keyRestrictionFunction;
    constructor(__formGroupDirective: FormGroupDirective);
    ngOnChanges(changes: SimpleChanges): void;
    _runReplacement(): void;
    private __setValidators;
    private __pendingSubscription;
    protected readonly __control: AbstractControl;
    __controlInfo(controlType: FormFieldControlType): {
        name: string;
        type: FormFieldControlType;
        abstractControl: AbstractControl;
    };
    readonly valid: boolean;
    readonly error: string;
    protected _cleanMaskValue(val: string): string;
}
